
AddCSLuaFile( "cl_init.lua" )
AddCSLuaFile( "shared.lua" )

include('shared.lua')

function ENT:SpawnFunction(ply, tr)
	if (!tr.Hit) then return end
	local SpawnPos = tr.HitPos + tr.HitNormal * 16
	local ent = ents.Create("unibeam_cannon_fast")
        ent:SetOwner(self.Owner) 
        ent:SetPos(SpawnPos)
	ent:Spawn()
	ent:Activate()
	ent:SetName("Unibeam Cannon")
	return ent
end

function ENT:Use(activ, ply)
	if activ:KeyDownLast(IN_USE) then return end
	if (not ply:IsPlayer()) then return end
        if !self.active1 then
        self.Sound2:Play()
        self.timer1 = CurTime() + 5
        self.active1 = true
        end

end

function ENT:Think()
        if self.active1 and self.timer1 <= CurTime() then
            self.Sound1:Play()
            local physobj = self:GetPhysicsObject()
            physobj:SetVelocity(Vector(0,0,1000))
            self.Entity:SetAngles(Angle(180, 0, 0))
            self.timer2 = CurTime() + 1
            self.active2 = true
            self.active1 = false
        end
        if self.active2 and self.timer2 <= CurTime() then
            self.Entity:SetMoveType(MOVETYPE_NONE)
            self.Entity:SetSolid(SOLID_NONE)
            local vStart = self.Entity:GetPos()
            local vForward = Vector(0, 0, -180)
            local trace = {}
            trace.start = vStart
            trace.endpos = vStart + (vForward * 2048)
            local tr = util.TraceLine( trace )
            local hitpos = tr.HitPos
            local effectdata = EffectData()
            effectdata:SetStart( self.Entity:GetPos())
            effectdata:SetOrigin(tr.HitPos)
            effectdata:SetScale( 100 )
            util.Effect( "iron_unibeam", effectdata ) 
            local uniexplosion = ents.Create("env_explosion")
            uniexplosion:SetPos(tr.HitPos)
            uniexplosion:SetKeyValue("iMagnitude", "250")
            uniexplosion:Spawn()
            uniexplosion:SetOwner(trace.HitPos)
            uniexplosion:Fire("explode", "", 0)
            uniexplosion:Fire("kill", "", 0)
	    local explosioneffect = ents.Create( "prop_combine_ball" )
	    explosioneffect:SetPos(self.Entity:GetPos())
	    explosioneffect:Spawn()
	    explosioneffect:Fire( "explode", "", 0 )
            self.Entity:Remove()
            self.active2 = false
         end

end	

function ENT:OnRemove()
	self.Sound1:Stop()
end

function ENT:Initialize()
        self.timer1 = 0
        self.timer2 = 0
        self.active1 = false
        self.active2 = false
	self.Sound1 = CreateSound(self.Entity, Sound("Weapon_Mortar.Incomming"))
	self.Sound2 = CreateSound(self.Entity, Sound("common/warning.wav"))
	self.Entity:SetModel("models/items/combine_rifle_ammo01.mdl")
	self.Entity:PhysicsInit(SOLID_VPHYSICS)
	self.Entity:SetMoveType(MOVETYPE_VPHYSICS)
	self.Entity:SetSolid(SOLID_VPHYSICS)
	local phys = self.Entity:GetPhysicsObject()
	if (phys:IsValid()) then
		phys:Wake()
	end
end