if ( SERVER ) then

	AddCSLuaFile( "shared.lua" )
	
end

if ( CLIENT ) then

	SWEP.PrintName			= "Iron Man v2.5"
	SWEP.Author			= "Kliker (Fixed by chowder908, edited by Frosty_Avo)"
        SWEP.Category 			= "Stark Industries"
	SWEP.Slot			= 1
	SWEP.SlotPos			= 0
	SWEP.IconLetter			= "f"
	SWEP.DrawCrosshair		= false
	
        killicon.AddFont( "weapon_deagle", "CSKillIcons",                 SWEP.IconLetter, Color( 255, 80, 0, 255 ) )


end

function SWEP:Deploy()
self.Weapon:EmitSound("weapons/iron_man/ironman.wav")
end

function SWEP:Reload()
if self.mode == 1 and CurTime() > self.changemode then
self.changemode = CurTime() + 1
self.Weapon:EmitSound("weapons/iron_man/v_unibeam.wav")
self.mode = 2
elseif self.mode == 2 and CurTime() > self.changemode then
self.changemode = CurTime() + 1
self.Weapon:EmitSound("weapons/iron_man/v_uninade.wav")
self.mode = 3
elseif self.mode == 3 and CurTime() > self.changemode then
self.changemode = CurTime() + 1
self.Weapon:EmitSound("weapons/iron_man/v_atomicimpact.wav")
self.mode = 1
end

end 
 

function SWEP:Think()
      if SERVER and !self.isflying then
            if self.Owner:KeyDown(IN_JUMP) then
            self.Owner:SetVelocity(self.Owner:GetUp() * 30)
            self.Weapon:EmitSound("weapons/iron_man/jetpack.wav")
            end
            
            if self.Owner:KeyDown(IN_FORWARD) and !self.Owner:IsOnGround() then
            self.Owner:SetVelocity(self.Owner:GetForward() * 20)
            self.Weapon:EmitSound("weapons/iron_man/jetpack.wav")
            end

            if self.Owner:KeyDown(IN_BACK) and !self.Owner:IsOnGround() then
            self.Owner:SetVelocity(self.Owner:GetForward() * -20)
            self.Weapon:EmitSound("weapons/iron_man/jetpack.wav")
            end

            if self.Owner:KeyDown(IN_MOVELEFT) and !self.Owner:IsOnGround() then
            self.Owner:SetVelocity(self.Owner:GetRight() * -20)
            self.Weapon:EmitSound("weapons/iron_man/jetpack.wav")
            end

            if self.Owner:KeyDown(IN_MOVERIGHT) and !self.Owner:IsOnGround() then
            self.Owner:SetVelocity(self.Owner:GetRight() * 20)
            self.Weapon:EmitSound("weapons/iron_man/jetpack.wav")
            end
      end

      if self.Owner:Health() < 500 and self.timehp <= CurTime() then
            if self.Owner:Health()+self.addhp > 500 then
            self.Owner:SetHealth(500)
            self.timehp = CurTime() + 0.2
            else
            self.Owner:SetHealth(self.Owner:Health()+self.addhp)
            self.timehp = CurTime() + 0.2
            end
      end

      if self.isflying == true then
            if self.Owner:IsOnGround() then
            if SERVER then
            local hitposent = ents.Create("info_target")
            local hitpos = self.Owner:GetPos() - Vector(0,0,10)
	    local explosioneffect = ents.Create( "prop_combine_ball" )
	    explosioneffect:SetPos(hitpos)
	    explosioneffect:Spawn()
	    explosioneffect:Fire( "explode", "", 0 )
	    local damage = ents.Create("point_hurt")
	    damage:SetKeyValue("DamageRadius", 1000)
	    damage:SetKeyValue("Damage" , 150)
	    damage:SetKeyValue("DamageDelay", 1)
	    damage:SetKeyValue("DamageType" ,"67108864")
	    damage:SetPos(self.Owner:GetPos())
            damage:SetParent(self.Owner)
	    damage:Fire("TurnOn" , "", 0)
	    damage:Fire("TurnOff" , "", 1)
	    damage:Fire("kill","", 2)
            self.emitsnd = true
            end
            if self.emitsnd then
            self.Weapon:EmitSound("weapons/mortar/mortar_explode2.wav")
            self.emitsnd = false
            end
            self.isflying = false
            end

      end

    if self.waituni < CurTime() and self.actuni then
        self.Weapon:EmitSound("weapons/mortar/mortar_explode3.wav")
        local trace = self.Owner:GetEyeTrace()
        local hitpos = trace.HitPos 
        local effectdata = EffectData()
        effectdata:SetStart( self.Owner:GetPos() + Vector(0,0,50))
        effectdata:SetOrigin( trace.HitPos )
        effectdata:SetScale( 100 )
        util.Effect( "iron_unibeam", effectdata ) 
        if SERVER then
        local uniexplosion = ents.Create("env_explosion")
        uniexplosion:SetPos(trace.HitPos)
        uniexplosion:SetKeyValue("iMagnitude", "250")
        uniexplosion:Spawn()
        uniexplosion:SetOwner(self.Owner)
        uniexplosion:Fire("explode", "", 0)
        uniexplosion:Fire("kill", "", 0)
        end
        self.actuni = false
    end

end

function SWEP:Initialize()
self.nadetime = 0
self.addhp = 5
self.timehp = 0
self.mode = 1
self.addhealth = 0
self.changemode = 0
self.waituni = 0
if SERVER then self:SetWeaponHoldType( "melee" ) end

end
 
function SWEP:PrimaryAttack()
self.Weapon:SendWeaponAnim(ACT_VM_HITCENTER)
self.Weapon:SetNextPrimaryFire(CurTime() + .2)

local trace = self.Owner:GetEyeTrace()

if trace.HitPos:Distance(self.Owner:GetShootPos()) <= 75 then
	bullet = {}
	bullet.Num    = 1
	bullet.Src    = self.Owner:GetShootPos()
	bullet.Dir    = self.Owner:GetAimVector()
	bullet.Spread = Vector(0, 0, 0)
	bullet.Tracer = 0
	bullet.Force  = 9999999
	bullet.Damage = 125
        self.Owner:FireBullets(bullet)
        self.Owner:SetAnimation( PLAYER_ATTACK1 );
        self.Weapon:EmitSound("weapons/mortar/mortar_explode2.wav")
        if SERVER then
        local hitposent = ents.Create("info_target")
        local trace = self.Owner:GetEyeTrace()
        local hitpos = trace.HitPos
	local explosioneffect = ents.Create("prop_combine_ball")
        explosioneffect:SetOwner(self:GetOwner())
	explosioneffect:SetPos(hitpos)
	explosioneffect:Spawn()
	explosioneffect:Fire( "explode", "", 0 )
        end
else
	self.Weapon:EmitSound("weapons/iceaxe/iceaxe_swing1.wav")
	self.Weapon:SendWeaponAnim(ACT_VM_MISSCENTER)
end

end
 
function SWEP:SecondaryAttack()
if self.mode == 1 and !self.isflying and self.Owner:IsOnGround() then
        self.jumpcount = CurTime() + 0.5
        self.isflying = true
        self.islanding = false
        if SERVER then
        self.Owner:SetVelocity(Vector(0,0,750))
        end
        self.Weapon:EmitSound("Weapon_Mortar.Incomming")

elseif self.mode == 2 and !self.actuni then
        self.Weapon:EmitSound("weapons/iron_man/repulsor.wav")
        self.actuni = true
        self.waituni = CurTime() + 1

elseif self.mode == 3 and self.nadetime <= CurTime() then
	self.Weapon:EmitSound("weapons/iceaxe/iceaxe_swing1.wav")
        self.Weapon:SendWeaponAnim(ACT_VM_HITCENTER)
        if SERVER then
        local UniNade = ents.Create( "unibeam_cannon_fast" )
	UniNade:SetOwner( self:GetOwner() )
	UniNade:SetPhysicsAttacker( self:GetOwner() )
	UniNade:SetPos( self.Owner:GetShootPos() )
	UniNade:Spawn()
	UniNade:Activate()
        UniNade:SetVar("timer1",CurTime() + 2)
        UniNade:SetVar("active1",true)
	local UniNadePhys = UniNade:GetPhysicsObject()
	UniNadePhys:ApplyForceCenter( self.Owner:GetAimVector() * 500 )
        end
        self.nadetime = CurTime() + 1
end

end

SWEP.Author = "Kliker"
SWEP.Contact = ""
SWEP.Purpose = "I AM IRON MAN!"
SWEP.Instructions = "Primary - Atomic Punch. Secondary - Attack Mode. Reload - Select attack mode."
SWEP.Spawnable = true
SWEP.AdminSpawnable  = true

SWEP.ViewModel = "models/weapons/v_fists.mdl"
SWEP.WorldModel = "models/weapons/w_fists.mdl"

SWEP.Primary.Delay = 0.2
SWEP.Primary.Recoil = 0
SWEP.Primary.Damage = 100
SWEP.Primary.NumShots = 1	
SWEP.Primary.Cone = 0 	
SWEP.Primary.ClipSize = -1	
SWEP.Primary.DefaultClip = -1	
SWEP.Primary.Automatic = false
SWEP.Primary.Ammo = "none"

SWEP.Secondary.Delay = 0
SWEP.Secondary.Recoil = 0
SWEP.Secondary.Damage = 0
SWEP.Secondary.NumShots = 1
SWEP.Secondary.Cone = 0
SWEP.Secondary.ClipSize	= -1
SWEP.Secondary.DefaultClip = -1
SWEP.Secondary.Automatic = false
SWEP.Secondary.Ammo = "none"